// Copyright 2004-2008 John Eblen
// Department of Computer Science
// University of Tennessee
//
// This file is part of Paraclique.            
//
// Paraclique is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by   
// the Free Software Foundation, either version 3 of the License, or   
// (at your option) any later version.   
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of   
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
// GNU General Public License for more details.   
//
// You should have received a copy of the GNU General Public License   
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "Clique_Test.h"

bool Edge_Test::operator() (const Graph::Vertices &v, int min_size, int node)
                                                                        const
{
  if (node != -1)
  {
    cerr << "Error - edge test called with specific node." << endl;
    exit(EXIT_FAILURE);
  }

  int degree_sum = 0;
  const int degree_sum_needed = min_size * (min_size - 1);
  Graph::Vertices::Vex_ptr vp(v);

  for (; !vp.end(); ++vp)
  {
    degree_sum += v.degree(*vp);
    if (degree_sum >= degree_sum_needed) return 0;
  }

  return 1;
}
