// Copyright 2004-2008 John Eblen
// Department of Computer Science
// University of Tennessee
//
// This file is part of Paraclique.            
//
// Paraclique is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by   
// the Free Software Foundation, either version 3 of the License, or   
// (at your option) any later version.   
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of   
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
// GNU General Public License for more details.   
//
// You should have received a copy of the GNU General Public License   
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// July 19, 2006
// Function for preprocessing by degree.  These preprocessing tests do not
// fit the mold for a general clique test used by the Preprocessor.  They
// work by finding nodes that ARE in the clique.  Thus, they are implemented
// separately.  At present, there are not enough of these tests to justify
// a general preprocessing algorithm based on them.  There is also no
// general theory developed to implement it.  Perhaps someday...

#ifndef _DEGREE_PREPROCESSOR_H
#define _DEGREE_PREPROCESSOR_H 1

#include "Graph.h"
using namespace std;

int Degree_Preprocessor(Graph::Vertices &mygraph, Graph::Vertices &clique,
                                                           int *ldnode = 0);

#endif
