// Copyright 2004-2008 John Eblen
// Department of Computer Science
// University of Tennessee
//
// This file is part of Paraclique.            
//
// Paraclique is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by   
// the Free Software Foundation, either version 3 of the License, or   
// (at your option) any later version.   
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of   
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
// GNU General Public License for more details.   
//
// You should have received a copy of the GNU General Public License   
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#include "MC_Heuristic.h"

int Greedy_Clique::operator() (Graph::Vertices &subgraph,
                                               Graph::Vertices &clique) const
{
  int hdnode;
  Graph::Vertices candidates(subgraph);

  while (candidates.size() > 0)
  {
    hdnode = candidates.hdvertex();
    candidates.remove_nnbrs(hdnode);
    candidates.remove(hdnode);
    clique.insert(hdnode);
  }

  return clique.size();
}
