// Copyright 2004-2008 John Eblen
// Department of Computer Science
// University of Tennessee
//
// This file is part of Paraclique.            
//
// Paraclique is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by   
// the Free Software Foundation, either version 3 of the License, or   
// (at your option) any later version.   
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of   
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
// GNU General Public License for more details.   
//
// You should have received a copy of the GNU General Public License   
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// August 2, 2006
// An array that maps byte i to the number of 1 bits in that byte.
// NOTE:  This header contains some architecture-specific definitions
// (see below)

#ifndef _BIT_COUNTERS_H
#define _BIT_COUNTERS_H 1

// Architecture dependent - uint2b must be a 2-byte unsigned integer
typedef unsigned short int uint2b;

int count_ones(unsigned long ul);
int count_ones(unsigned long *, int);
int count_ones_fast(unsigned long *, int);

#endif
