// Copyright 2004-2008 John Eblen
// Department of Computer Science
// University of Tennessee
//
// This file is part of Paraclique.            
//
// Paraclique is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by   
// the Free Software Foundation, either version 3 of the License, or   
// (at your option) any later version.   
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of   
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
// GNU General Public License for more details.   
//
// You should have received a copy of the GNU General Public License   
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

// August 4, 2006
// A collection of functions for coloring graphs.  These are often used by
// both clique testing functions and candidate managers.
// At present, there is only one function, which does greedy coloring and
// is used by the Color_Test and color managers.  Coloring, though, is an
// important part of strategies for clique hunting, and so I suspect this
// library will grow.

#ifndef _COLORING_H
#define _COLORING_H 1

#include "Graph.h"
using namespace std;

// This function greedily colors the given nodes in subgraph sg in REVERSE
// order (nodes should ideally be sorted lowest to highest degree when passed).
// It returns the number of colors needed (an upper bound on the clique size).
// If passed, node2color is a mapping of each node to its color, and
// sorted_nodes is an array of the nodes sorted from high to low color value.
// Warning:  See warnings in source.
int color_subgraph(const Graph::Vertices &sg, vector<int> *node2color = 0,
                                              vector<int> *sorted_nodes = 0);
#endif
