#!/usr/bin/perl

# Copyright 2004-2008 John Eblen
# Department of Computer Science
# University of Tennessee
#
# This file is part of Paraclique.            
#
# Paraclique is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by   
# the Free Software Foundation, either version 3 of the License, or   
# (at your option) any later version.   
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of   
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the   
# GNU General Public License for more details.   
#
# You should have received a copy of the GNU General Public License   
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# October 1, 2007
# Script for easy running of paraclique programs.

# Hard-coded paraclique parameters
$min_max_clique_size = 20;  # 0 to ignore (= 3)
$min_paracl_size = 0;  # 0 means (= 3)
$max_no_paracls = 0;   # 0 means (= INF)

# Temporary files
$TMP_PARACL_OUT = "/local_scratch/paracl.$$";

# Check command-line arguments
if (scalar(@ARGV) < 2)
{
  print "Usage:  paracl.pl <DIMACS Graph> <Parameter> <Optional Algorithm Type>\n";
  exit;
}
$algorithm = "ho";
if (scalar(@ARGV) > 2)
{
  if ($ARGV[2] =~ /^a/) {$algorithm = "ha";}
  elsif ($ARGV[2] =~ /^o/) {$algorithm = "so";}
  elsif ($ARGV[2] =~ /^b/) {$algorithm = "sa";}
  else
  {
    print "Error - algorithm type must be [a]ccelerated, [o]verlap, or [b]oth\n";
    exit;
  }
}

if ($algorithm =~ /^.a/ && $ARGV[1] < 2)
{
  print "Error - accelerated paraclique requires paramater >= 2\n";
  exit;
}
if ($ARGV[1] < 1)
{
  print "Error - parameter must be >= 1\n";
  exit;
}

# Run paraclique
open(PARACL, "./paracl_$algorithm $ARGV[0] $ARGV[1] $min_max_clique_size $min_paracl_size $max_no_paracls |");
while (my $line = <PARACL>) {print $line;}
close PARACL;
